<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 35.10</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
      .editFrame {
        background-color: #e9ecef;
        margin-bottom: 1rem;
        padding: 1rem 0rem;
        text-align: center;
      }
    </style>
  </head>
  <body onload="onPageLoading()">
    <div class="container">
      <div class="text-center my-4">
        <h3>DANH SÁCH NGƯỜI DÙNG</h3>
      </div>
      <div class="editFrame">
        <div class="row form-group">
          <div class="col-sm-3">
            <label>Name</label>
          </div>

          <div class="col-sm-6">
            <input
              type="text"
              class="form-control"
              id="inp-name"
              placeholder="..."
            />
          </div>
          <div class="col-sm-3">
            <button class="btn btn-success" id="btn-filter">
              Filter users
            </button>
          </div>
        </div>
      </div>

      <table
        class="table table-bordered table-striped table-hover"
        id="tbl-user"
      >
        <thead class="text-center">
          <tr class="bg-info text-white">
            <th>STT</th>
            <th>Name</th>
            <th>Username</th>
            <th>Email</th>
            <th>Address</th>
            <th>Zip code</th>
            <th>Phone</th>
            <th>Company</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>

    <script>
      "use strict";

      /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
      const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
      const gLIST_ALL_USER = [];

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        //gán sự kiện nút nhấn fillter user
        $("#btn-filter").on("click", onBtnFilterClick);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //call sever by get ajax
      function onPageLoading() {
        $.ajax({
          url: gBASE_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            //console.log(JSON.stringify(responseObject)); //response text
            gLIST_ALL_USER.push(responseObject);
            console.log(gLIST_ALL_USER);
            //4 xử lý hiện thị
            loadTableCommentPostData(responseObject); // responseObject là array các posts
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          },
        });
      }

      function onBtnDetailClick() {
        "use strict";
        console.log("id của user bạn cần là: " + $(this).data("id"));
        const vFORM_TO_OPEN = "userdetail.html";
        var vUrlToOpenPage = vFORM_TO_OPEN + "?id=" + $(this).data("id");
        window.location.href = vUrlToOpenPage;
      }

      function onBtnFilterClick(params) {
        "use strict";
        //b0:tạo obj truyền vào
        var vFilterObj = {
          name: "",
        };
        //b1: thu thập dữ liệu
        readDataInputName(vFilterObj);
        //b2: validate không cần
        //b3: thực hiện việc tìm kiếm và xủ lý hiển thị
        var vArrUserFiltered = findUserByFilter(vFilterObj);
        var vTable = $("#table-users"); //truy vấn đến bảng có id = table-users
        vTable.find("tr:gt(0)").html(""); //xóa trắng bảng (không xóa head)
        if (vArrUserFiltered.length > 0) {
          //hiện thông báo đã tìm được
          alert("Tìm thấy " + vArrUserFiltered.length + " kết quả phù hợp!");
          //hiển thị danh sách dữ liệu tìm được ra table
          loadTableCommentPostData(vArrUserFiltered);
        } else {
          alert("Không tìm thấy kết quả phù hợp");
          return false;
        }
      }

      //hàm thu thập dữ liệu
      function readDataInputName(paramKeyWordObj) {
        "use strict";
        var vInputName = $("#inp-name");
        paramKeyWordObj.name = $.trim(vInputName.val());
      }

      /*
    hàm xử lý tìm kiếm user
    - input/start: paramKeyWordObj: (là 1 object chứa cá key word đã thu thập từ form: name)
    - output/end: trả về 1 array gồm các object (user)
    */
      function findUserByFilter(paramKeyWordObj) {
        "use strict";
        const bArrResultObj = [];

        //kiểm tra trường hợp nếu name được nhập
        if (paramKeyWordObj.firstname != "") {
          for (var bI = 0; bI < gLIST_ALL_USER[0].length; bI++) {
            const bItemUserObj = gLIST_ALL_USER[0][bI];
            //thực hiện so sánh từ khóa được nhập vào với dữ liệu user
            if (
              paramKeyWordObj.name.toLowerCase() ===
              bItemUserObj.name.toLowerCase()
            ) {
              //thêm đối tượng thỏa mãn điều kiện vào Array
              bArrResultObj.push(bItemUserObj);
            }
          }
        }
        return bArrResultObj;
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm xóa dữ liệu table
      function resetDataTable() {
        $("#tbl-user tbody").html("");
      }

      //hiển thị dữ liệu lên table
      function loadTableCommentPostData(paramUserObj) {
        "use strict";
        //xóa dữ liệu table
        resetDataTable();

        //đổ data vào table
        for (var bI = 0; bI < paramUserObj.length; bI++) {
          //tạo row
          var bNewRow = $("<tr>").appendTo("#tbl-user tbody");

          //{"id":1,"name":"Leanne Graham","username":"Bret","email":"Sincere@april.biz","address":{"street":"Kulas Light","suite":"Apt. 556","city":"Gwenborough","zipcode":"92998-3874","geo":{"lat":"-37.3159","lng":"81.1496"}},"phone":"1-770-736-8031 x56442","website":"hildegard.org","company":{"name":"Romaguera-Crona","catchPhrase":"Multi-layered client-server neural-net","bs":"harness real-time e-markets"}}
          //tạo cell
          var bArrObj = paramUserObj[bI];
          $("<td>").html(bArrObj.id).appendTo(bNewRow);
          $("<td>").html(bArrObj.name).appendTo(bNewRow);
          $("<td>").html(bArrObj.username).appendTo(bNewRow);
          $("<td>").html(bArrObj.email).appendTo(bNewRow);
          $("<td>")
            .html(
              bArrObj.address.suite +
                ", " +
                bArrObj.address.street +
                ", " +
                bArrObj.address.city
            )
            .appendTo(bNewRow);
          $("<td>").html(bArrObj.address.zipcode).appendTo(bNewRow);
          $("<td>").html(bArrObj.phone).appendTo(bNewRow);
          $("<td>").html(bArrObj.company.name).appendTo(bNewRow);

          //xử lý cột Action
          var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);
          var bNewButtonDetail = $("<button>", { html: "Chi Tiết" })
            .addClass("btn btn-info")
            .data("id", bArrObj.id)
            .appendTo(bColAction);

          //thêm event for button detail
          bNewButtonDetail.click(onBtnDetailClick);
        }
      }
    </script>
  </body>
</html>
